#include "download.h"

struct FtpFile {
char filename[100];
FILE *stream;
};

static size_t my_fwrite(void *buffer, size_t size, size_t nmemb, void *stream)
{
struct FtpFile *out=(struct FtpFile *)stream;
if(out && !out->stream) {
/* open file for writing */
out->stream=fopen(out->filename, "wb");
if(!out->stream)
return -1; /* failure, can't open file to write */
}
return fwrite(buffer, size, nmemb, out->stream);
}


int download(const char *adresse, const char *filetosave)
{
CURL *curl;
CURLcode res;
struct FtpFile ftpfile;
sprintf(ftpfile.filename, "%s", filetosave);
ftpfile.stream = NULL;

curl = curl_easy_init();

    if(curl) {
    curl_easy_setopt(curl, CURLOPT_URL, adresse);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, my_fwrite);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, &ftpfile);
    res = curl_easy_perform(curl);
    curl_easy_cleanup(curl);
    }
fclose(ftpfile.stream);
return 0;
}
