#include "fupload.h"

static size_t read_callback(void *ptr, size_t size, size_t nmemb, void *stream)
{
    size_t retcode = fread(ptr, size, nmemb, stream);
    fprintf(stderr, "*** We read %d bytes from file\n", retcode);
return retcode;
}

void clean(char *buff)
{
int i;
    for(i = 0; i < (int)strlen(buff); i++)
    {
        if(buff[i] == '\n') buff[i] = '\0';
    }
}

int upload(const char *filetoupload)
{
    CURL *curl;
    CURLcode res;
    FILE *hd_src;
    struct stat file_info;
    struct curl_slist *headerlist=NULL;
    static char buf_1 [1000] = "RNFR ";
    char remote_url[500] = "ftp://";
    char buffer[200] = "";
    sprintf(buf_1,"%s%s", buf_1, filetoupload);
    FILE *logfile = fopen("./login.txt", "r");
    if(logfile)
    {
    fgets(buffer, 500, logfile); clean(buffer);
    sprintf(remote_url,"%s%s:", remote_url, buffer);
    fgets(buffer, 500, logfile); clean(buffer);
    sprintf(remote_url,"%s%s@", remote_url, buffer);
    fgets(buffer, 500, logfile); clean(buffer);
    sprintf(remote_url,"%s%s/", remote_url, buffer);
    }
    fclose(logfile);
    sprintf(remote_url,"%s%s", remote_url, filetoupload);

    /* get the file size of the local file */
    if(stat(filetoupload, &file_info)) {
     printf("Couldnt open '%s': %s\n", filetoupload, strerror(errno));
     return 1;
    }
    printf("Local file size: %ld bytes.\n", file_info.st_size);

    /* get a FILE * of the same file */
    hd_src = fopen(filetoupload, "rb");

    /* In windows, this will init the winsock stuff */
    curl_global_init(CURL_GLOBAL_ALL);

    /* get a curl handle */
    curl = curl_easy_init();
    if(curl)
    {
    /* build a list of commands to pass to libcurl */
    headerlist = curl_slist_append(headerlist, buf_1);

    /* we want to use our own read function */
    curl_easy_setopt(curl, CURLOPT_READFUNCTION, read_callback);

    /* enable uploading */
    curl_easy_setopt(curl, CURLOPT_UPLOAD, 1L);

    /* specify target */
    curl_easy_setopt(curl,CURLOPT_URL, remote_url);

    /* pass in that last of FTP commands to run after the transfer */
    curl_easy_setopt(curl, CURLOPT_POSTQUOTE, headerlist);

    /* now specify which file to upload */
    curl_easy_setopt(curl, CURLOPT_READDATA, hd_src);

    /* Set the size of the file to upload (optional).  If you give a *_LARGE
       option you MUST make sure that the type of the passed-in argument is a
        curl_off_t. If you use CURLOPT_INFILESIZE (without _LARGE) you must
        make sure that to pass in a type 'long' argument. */
    curl_easy_setopt(curl, CURLOPT_INFILESIZE_LARGE, (curl_off_t)file_info.st_size);

    /* Now run off and do what you've been told! */
    res = curl_easy_perform(curl);

    /* clean up the FTP commands list */
    curl_slist_free_all(headerlist);

    /* always cleanup */
    curl_easy_cleanup(curl);
    }
    fclose(hd_src); /* close the local file */

    curl_global_cleanup();
return 0;
}

