/*
 *  Copyright (C) 2008 Human-Behind (human-behind@hotmail.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "download.h"

struct FtpFile {
char filename[100];
FILE *stream;
};

static size_t my_fwrite(void *buffer, size_t size, size_t nmemb, void *stream)
{
struct FtpFile *out=(struct FtpFile *)stream;
if(out && !out->stream) {
/* open file for writing */
out->stream=fopen(out->filename, "wb");
if(!out->stream)
return -1; /* failure, can't open file to write */
}
return fwrite(buffer, size, nmemb, out->stream);
}


int download(const char *adresse, const char *filetosave)
{
CURL *curl;
CURLcode res;
struct FtpFile ftpfile;
sprintf(ftpfile.filename, "%s", filetosave);
ftpfile.stream = NULL;

curl = curl_easy_init();

    if(curl) {
    curl_easy_setopt(curl, CURLOPT_URL, adresse);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, my_fwrite);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, &ftpfile);
    res = curl_easy_perform(curl);
    curl_easy_cleanup(curl);
    }
fclose(ftpfile.stream);
return 0;
}
